package djmil.cordacheckers.cordaclient;

import java.util.List;

import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpMethod;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Service;
import org.springframework.web.client.RestTemplate;

import djmil.cordacheckers.cordaclient.pojo.virtualNodes;
import djmil.cordacheckers.cordaclient.pojo.virtualnode;

@Service
public class CordaClient {
    private final RestTemplate restTemplate;

    public CordaClient(RestTemplate restTemplate) {
        //System.out.println("Creating REST Service");
        // this.restTemplate = restTemplateBuilder
        //     .basicAuthentication("admin", "admin")
        //     .build();
        this.restTemplate = restTemplate;
    }

    public List<virtualNodes> getVirtualnode() {

        // Request authorization header
		HttpHeaders headers = new HttpHeaders();
		headers.setBasicAuth("admin", "admin");
		
		// Request
		final HttpEntity<String> request = new HttpEntity<>(headers);

        ResponseEntity<virtualnode> resp = this.restTemplate.exchange(
            "https://localhost:8888/api/v1/virtualnode",
            HttpMethod.GET, 
            request, 
            virtualnode.class );

        // TODO: throw exeption instead
        if (resp.getStatusCode() != HttpStatus.OK || !resp.hasBody()) {
            return null;
        }

        return resp.getBody().virtualNodes();
    }
}
